.586
.model flat,stdcall
option casemap:none

   include windows.inc
   include user32.inc
   include kernel32.inc
   include scintilla.inc
   
   includelib user32.lib
   includelib kernel32.lib

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

funcx TYPEDEF PROTO CDECL :DWORD,:DWORD,:DWORD,:DWORD
funcy TYPEDEF PTR funcx



.data
	ClassName db "MainWinClass",0
	AppName   db "Main Window" ,0
	sciclass  db "Scintilla"   ,0
	libstr    db "SciLexer.dll",0    

.data?
	hInstance   dd ?
	CommandLine dd ?
	hmod        dd ?
	sciH        dd ?
	SciPTR     dd ?
	SciSend funcy ? ;function for scintilla control
.code


; ---------------------------------------------------------------------------


start:
	invoke GetModuleHandle, NULL
	mov    hInstance, eax
	
	invoke GetCommandLine
	mov    CommandLine, eax
	
	invoke LoadLibrary, ADDR libstr
	mov    hmod, eax
	
	invoke WinMain, hInstance, 0, CommandLine, SW_SHOWDEFAULT
	
	invoke FreeLibrary, hmod
	
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,  0
	mov   wc.cbWndExtra,  0
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground, COLOR_BTNFACE+1
	mov   wc.lpszMenuName,  0
	mov   wc.lpszClassName, OFFSET ClassName
	
	invoke LoadIcon, 0, IDI_APPLICATION
	mov    wc.hIcon,   eax
	mov    wc.hIconSm, eax
	
	invoke LoadCursor, 0, IDC_ARROW
	mov    wc.hCursor,  eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_CAPTION+WS_CLIPSIBLINGS+WS_SYSMENU+WS_SIZEBOX+WS_CLIPCHILDREN,10,10,400,400,0,0,hInst, 0
	mov    hwnd, eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage,  ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
	
	mov    eax, uMsg
	.IF     eax == WM_DESTROY
		invoke PostQuitMessage, 0
	.ELSEIF eax == WM_CREATE
		invoke CreateWindowEx, WS_EX_STATICEDGE, ADDR sciclass, 0, WS_VISIBLE+WS_CHILD,\
			10, 10, 200, 200, hWin, 0, hInstance, 0
		mov    sciH, eax
		
		mov    SciSend,  FUNC(SendMessage, sciH, SCI_GETDIRECTFUNCTION, 0, 0)
		mov    SciPTR,   FUNC(SendMessage, sciH, SCI_GETDIRECTPOINTER,  0, 0)
		
		invoke SciSend, SciPTR, SCI_SETSELFORE, 1, 0ff00h
		invoke SciSend, SciPTR, SCI_SETSELBACK, 1, 000ffh
		 
		
	.ELSEIF eax == WM_SIZE
		mov    eax, lParam
		mov    ecx, eax
		and    eax, 0ffffh
		shr    ecx, 16
		sub    eax, 20
		sub    ecx, 20
		invoke MoveWindow, sciH, 10, 10, eax, ecx, 1
	.ELSE
		invoke DefWindowProc, hWin, uMsg, wParam, lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp


end start
